// Harmonic Analyzer Settings struct
// Copyright 2006 Chad Berchek

#ifndef HASETTINGS_H
#define HASETTINGS_H

#include "wavetypes.h"

// Harmonic analyer settings
struct haSettings {
	samplingRateT sampleRate; // sampling rate in Hz
	timeT toneDuration;       // desired approximate minimum duration for DFT
	double maxFractionalCycle; // maximum fraction of a cycle of input frequency to allow
	cycleCountT minNumCycles; // miniumum number of cycles of input frequency to allow
	timeT maxExtraTime; // maximum extra time to add to toneDuration for improved DFT accuracy
	sampleT silenceThreshold; // sample value below which samples will be interpreted as silence
	sampleCountT FFT_LEN;     // length of FFT to use for fundamental detection
	sampleCountT osampOffset; // offset from start of first FFT frame to second
	timeT breakLengthThreshold; // length of silence that will be considered a break. in seconds
	unsigned int numHarmonics; // number of harmonics to analyze
	unsigned int peakDetectThreshold; // the average FFT magnitude times this number is the threshold
												 // for detecting the first peak of the amplitude spectrum
	timeT attackSkipDuration; // length of time in seconds to skip at beginning of each tone
	unsigned int numPeaks; // number of peaks to consider when searching for fundamental freq. bin
};

#endif
