// MiscMath.cpp  Misc. math functions
// Copyright 2006 Chad Berchek except mapToPi function

/* Revisions:
	1.1 - added mapToPi
		 - added safeAtan2
		 - removed roundToShort
		 - added isWithin and isWithinD to miscmath.h
		 - added M_2PI to miscmath.h

	1.0 - first version
*/

#include <cmath>
#include "miscmath.h"
using namespace std;

double fround(double x) {
	if (x > 0.) return floor(x + 0.5);
	else if (x < 0.) return ceil(x - 0.5);
	return x;
}

// Maps input angle to the range -pi to +pi by adding or subtracting 2*pi
double mapToPi(double tmp) {
/**** THIS FUNCTION ONLY ***************************************************/
/* COPYRIGHT 1999-2003 Stephan M. Bernsee <smb [AT] dspdimension [DOT] com>
*
* 						The Wide Open License (WOL)
*
* Permission to use, copy, modify, distribute and sell this software and its
* documentation for any purpose is hereby granted without fee, provided that
* the above copyright notice and this license appear in all source copies.
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF
* ANY KIND. See http://www.dspguru.com/wol.htm for more information.
*
*****************************************************************************/
	long qpd;
	qpd = static_cast<long>(tmp/M_PI);
	if (qpd >= 0) qpd += qpd&1;
	else qpd -= qpd&1;
	tmp -= M_PI*(double)qpd;
	return tmp;
}

// Returns 0 in case x and y = 0
double safeAtan2(double x, double y) {
	if (x == 0. && y == 0.) return 0;
	else return atan2(x, y);
}
